﻿using System;
using System.Windows.Forms;
using ELTE.BoardGame.Model;
using ELTE.BoardGame.Persistence;
using ELTE.BoardGame.View;
using ELTE.IoC;
using Microsoft.Practices.Unity;
using Microsoft.Practices.Unity.Configuration;

namespace ELTE.BoardGame
{
    static class Program
    {
        /// <summary>
        /// The main entry point for the application.
        /// </summary>
        [STAThread]
        static void Main()
        {
            Application.EnableVisualStyles();
            Application.SetCompatibleTextRenderingDefault(false);

            // függőség befecskendezés több szinten
            //IPersistence persistence = new TextFilePersistence();
            //BoardGameModel model = new ConnectFourModel(10, persistence);
            //Form view = new DrawingForm(model);

            // IoC tároló használata
            Container container = new Container();
            container.Register<IPersistence, BinaryFilePersistence>();
            container.Register<BoardGameModel, TicTacToeModel>();
            container.Register<Form, ControlsForm>();

           // IUnityContainer container = new UnityContainer();
           // container.LoadConfiguration(); // konfiguráció betöltése

            // Application.Run(view);
            Application.Run(container.Resolve<Form>()); // függőséglánc feloldása
        }
    }
}
